import logging

from waveapi import element
from waveapi import events
from waveapi import robot
from waveapi import appengine_robot_runner

import urllib2, urllib, httplib;

GADGET_BASE = 'http://pgibot.appspot.com'
GADGET_NAME = 'PGI Robot'
GADGET_URL = '%s/static/gadget.xml' % GADGET_BASE
GADGET_IMAGE_URL = '%s/images/logo.png' % GADGET_BASE

def OnWaveletSelfAdded(event, wavelet):
  """Invoked when the robot has been added"""
  blip = wavelet.reply()
  gadget = element.Gadget(url=GADGET_URL)
  blip.append(gadget)

def OnGadgetStateChanged(event, wavelet):
  blip = event.blip
  gadgetRef = blip.first(element.Gadget, url=GADGET_URL)
  gadget = gadgetRef.value()
  if gadget.get('exporting') == 'yes':    
    content = gadget.get('rdf').encode('utf-8')
    url1 = '%s/save' %GADGET_BASE
    values1 = {'content': content}
    data1 = urllib.urlencode(values1)
    req1 = urllib2.Request(url1, data1)
    response1 = urllib2.urlopen(req1)
    gadgetRef.update_element({'uploadStatus': 'uploaded'})
    res_str1 = response1.read().strip(' ')
    #wavelet.reply(res_str1)
    url2 = 'http://lab.gsi.dit.upm.es/~adam/ideastream/?q=admin/settings/rdfme/rest/import'
    values2 = {'name':'admin',
        'pass':'1cd907d0c4e7591518f66056add9f9b9',
        'url':'%s/rdf/%s' %(GADGET_BASE,res_str1)}		
    data2 = urllib.urlencode(values2)
    req2 = urllib2.Request(url2, data2)
    response2 = urllib2.urlopen(req2)
    res_str2 = response2.read()
    #wavelet.reply(res_str2)
    gadgetRef.update_element({'exporting': 'no'})

if __name__ == '__main__':
  pgibot = robot.Robot(GADGET_NAME,
      image_url = GADGET_IMAGE_URL,
      profile_url = GADGET_BASE)
  pgibot.register_handler(events.WaveletSelfAdded, OnWaveletSelfAdded)
  pgibot.register_handler(events.GadgetStateChanged, OnGadgetStateChanged)
  appengine_robot_runner.run(pgibot, debug=True)
